Index: squid3/src/tests/testHttpRequestMethod.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testHttpRequestMethod.cc,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/tests/testHttpRequestMethod.cc	2 Sep 2006 03:54:27 -0000	1.2
+++ squid3/src/tests/testHttpRequestMethod.cc	18 May 2007 06:41:33 -0000	1.3
@@ -79,7 +79,7 @@
 void
 testHttpRequestMethod::testConst_str()
 {
-    CPPUNIT_ASSERT_EQUAL(String("POST"), String(HttpRequestMethod("post").const_str()));
+    CPPUNIT_ASSERT_EQUAL((string)"POST", (string)HttpRequestMethod("post").const_str());
 }
 
 /*
@@ -115,5 +115,5 @@
 {
     std::ostringstream buffer;
     buffer << HttpRequestMethod("get");
-    CPPUNIT_ASSERT_EQUAL(String("GET"), String(buffer.str().c_str()));
+    CPPUNIT_ASSERT_EQUAL((string)"GET", (string)buffer.str().c_str() );
 }
Index: squid3/src/tests/testStore.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testStore.cc,v
retrieving revision 1.4
retrieving revision 1.5
diff -u -r1.4 -r1.5
--- squid3/src/tests/testStore.cc	3 May 2006 14:04:45 -0000	1.4
+++ squid3/src/tests/testStore.cc	18 May 2007 06:41:33 -0000	1.5
@@ -21,7 +21,7 @@
 void
 
 TestStore::get
-    (String, void (*)(StoreEntry*, void*), void*)
+    (string, void (*)(StoreEntry*, void*), void*)
 {}
 
 void
@@ -48,7 +48,7 @@
 }
 
 StoreSearch *
-TestStore::search(String const url, HttpRequest *)
+TestStore::search(string const url, HttpRequest *)
 {
     return NULL;
 }
Index: squid3/src/tests/testStore.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testStore.h,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/tests/testStore.h	3 May 2006 14:04:45 -0000	1.2
+++ squid3/src/tests/testStore.h	18 May 2007 06:41:33 -0000	1.3
@@ -49,7 +49,7 @@
         (const cache_key*);
 
     virtual void get
-        (String, void (*)(StoreEntry*, void*), void*);
+        (string, void (*)(StoreEntry*, void*), void*);
 
     virtual void init();
 
@@ -67,7 +67,7 @@
 
     virtual void updateSize(size_t size, int sign) {}
 
-    virtual StoreSearch *search(String const url, HttpRequest *);
+    virtual StoreSearch *search(string const url, HttpRequest *);
 };
 
 typedef RefCount<TestStore> TestStorePointer;
Index: squid3/src/tests/testStoreController.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testStoreController.cc,v
retrieving revision 1.5
retrieving revision 1.6
diff -u -r1.5 -r1.6
--- squid3/src/tests/testStoreController.cc	21 Apr 2007 07:14:20 -0000	1.5
+++ squid3/src/tests/testStoreController.cc	18 May 2007 06:41:33 -0000	1.6
@@ -78,10 +78,9 @@
 static StoreEntry *
 addedEntry(StorePointer hashStore,
            StorePointer aStore,
-           String name,
-           String varySpec,
-           String varyKey
-
+           string name,
+           string varySpec,
+           string varyKey
           )
 {
     StoreEntry *e = new StoreEntry();
@@ -109,7 +108,7 @@
     EBIT_CLR(e->flags, KEY_PRIVATE);
     e->ping_status = PING_NONE;
     EBIT_CLR(e->flags, ENTRY_VALIDATED);
-    e->hashInsert((const cache_key *)name.buf());	/* do it after we clear KEY_PRIVATE */
+    e->hashInsert((const cache_key *)name.c_str());	/* do it after we clear KEY_PRIVATE */
     return e;
 }
 
Index: squid3/src/tests/testStoreEntryStream.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testStoreEntryStream.cc,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/tests/testStoreEntryStream.cc	7 Aug 2006 02:28:26 -0000	1.2
+++ squid3/src/tests/testStoreEntryStream.cc	18 May 2007 06:41:33 -0000	1.3
@@ -39,7 +39,7 @@
         stream.flush();
         CPPUNIT_ASSERT_EQUAL(1, anEntry->_buffer_calls);
         CPPUNIT_ASSERT_EQUAL(1, anEntry->_flush_calls);
-        CPPUNIT_ASSERT_EQUAL(String("some text   !"), anEntry->_appended_text);
+        CPPUNIT_ASSERT_EQUAL((string)"some text   !", (string)anEntry->_appended_text);
     }
 
     delete anEntry;
Index: squid3/src/tests/testStoreHashIndex.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testStoreHashIndex.cc,v
retrieving revision 1.4
retrieving revision 1.5
diff -u -r1.4 -r1.5
--- squid3/src/tests/testStoreHashIndex.cc	21 Apr 2007 07:14:20 -0000	1.4
+++ squid3/src/tests/testStoreHashIndex.cc	18 May 2007 06:41:33 -0000	1.5
@@ -59,9 +59,9 @@
 StoreEntry *
 addedEntry(StorePointer hashStore,
            StorePointer aStore,
-           String name,
-           String varySpec,
-           String varyKey
+           string name,
+           string varySpec,
+           string varyKey
 
           )
 {
@@ -90,7 +90,7 @@
     EBIT_CLR(e->flags, KEY_PRIVATE);
     e->ping_status = PING_NONE;
     EBIT_CLR(e->flags, ENTRY_VALIDATED);
-    e->hashInsert((const cache_key *)name.buf());	/* do it after we clear KEY_PRIVATE */
+    e->hashInsert((const cache_key *)name.c_str());	/* do it after we clear KEY_PRIVATE */
     return e;
 }
 
Index: squid3/src/tests/testString.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testString.cc,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/tests/testString.cc	7 Aug 2006 02:28:26 -0000	1.2
+++ squid3/src/tests/testString.cc	18 May 2007 06:41:33 -0000	1.3
@@ -21,41 +21,168 @@
 static Initer ensure_mempools;
 
 void
+testString::testDefaults()
+{
+    string aStr;
+
+    /* check this reports as empty */
+    CPPUNIT_ASSERT( aStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( (const char*)NULL, aStr.c_str() );
+    CPPUNIT_ASSERT_EQUAL( 0, aStr.size() );
+
+    string bStr("foo bar");
+
+    /* check copy constructor */
+    CPPUNIT_ASSERT( !bStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 7, bStr.size() );
+    CPPUNIT_ASSERT( NULL != bStr.c_str() );
+    CPPUNIT_ASSERT( memcmp(bStr.c_str(), "foo bar", 8) == 0 );
+}
+
+void
+testString::testBooleans()
+{
+    const string smStr("bar");
+    const string bgStr("foo");
+    const string eqStr("foo");
+    const string nqStr("food");
+
+   /* mathematical boolean operators */
+   CPPUNIT_ASSERT(!(bgStr == smStr ));
+   CPPUNIT_ASSERT(  bgStr != smStr );
+   CPPUNIT_ASSERT(  bgStr >  smStr );
+   CPPUNIT_ASSERT(!(bgStr <  smStr ));
+   CPPUNIT_ASSERT(  bgStr >= smStr );
+   CPPUNIT_ASSERT(!(bgStr <= smStr ));
+
+   /* reverse order to catch corners */
+   CPPUNIT_ASSERT(!(smStr == bgStr ));
+   CPPUNIT_ASSERT(  smStr != bgStr );
+   CPPUNIT_ASSERT(!(smStr >  bgStr ));
+   CPPUNIT_ASSERT(  smStr <  bgStr );
+   CPPUNIT_ASSERT(!(smStr >= bgStr ));
+   CPPUNIT_ASSERT(  smStr <= bgStr );
+
+   /* check identical to catch corners */
+   CPPUNIT_ASSERT(  bgStr == eqStr );
+   CPPUNIT_ASSERT(!(bgStr != eqStr ));
+   CPPUNIT_ASSERT(!(bgStr >  eqStr ));
+   CPPUNIT_ASSERT(!(bgStr <  eqStr ));
+   CPPUNIT_ASSERT(  bgStr >= eqStr );
+   CPPUNIT_ASSERT(  bgStr <= eqStr );
+
+   /* check _almost_ identical to catch corners */
+   CPPUNIT_ASSERT(!(bgStr == nqStr ));
+   CPPUNIT_ASSERT(  bgStr != nqStr );
+   CPPUNIT_ASSERT(!(bgStr >  nqStr ));
+   CPPUNIT_ASSERT(  bgStr <  nqStr );
+   CPPUNIT_ASSERT(!(bgStr >= nqStr ));
+   CPPUNIT_ASSERT(  bgStr <= nqStr );
+}
+
+void
+testString::testAppend()
+{
+    // FIXME: make tests for this.
+    string aStr("hello");
+
+    aStr.append(" world");
+    CPPUNIT_ASSERT_EQUAL( (string)"hello world", aStr );
+    aStr.append(" howsit", 7);
+    CPPUNIT_ASSERT_EQUAL( (string)"hello world howsit", aStr );
+
+    string bStr;
+    string cStr("hello");
+
+    /* corner cases */
+    bStr.append(NULL, 2);
+    CPPUNIT_ASSERT( bStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 0, bStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"", bStr );
+
+    bStr.append("hello", 5);
+    CPPUNIT_ASSERT( !bStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 5, bStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"hello", bStr );
+
+    bStr.append(NULL, 2);
+    CPPUNIT_ASSERT( !bStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 5, bStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"hello", bStr );
+
+    bStr.append(" world untroubled by things such as null termination", 6);
+    CPPUNIT_ASSERT( !bStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 11, bStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"hello world", bStr );
+
+    cStr.append(" wo");
+    CPPUNIT_ASSERT( !cStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 8, cStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"hello wo", cStr );
+
+    cStr.append("rld\0 untroubled by things such as null termination", 10);
+    CPPUNIT_ASSERT( !cStr.empty() );
+    CPPUNIT_ASSERT_EQUAL( 18, cStr.size() );
+    CPPUNIT_ASSERT_EQUAL( (string)"hello world\0 untr", cStr );
+}
+
+void
+testString::testAssignments()
+{
+    // FIXME: make tests for this.
+}
+
+void
+testString::testCstrMethods()
+{
+    // FIXME: make tests for this.
+    // strcmp, strncmp, etc....
+}
+
+void
+testString::testSearch()
+{
+    // FIXME: make tests for this.
+
+// pos, rpos, find, rfind, etc...
+}
+
+void
 testString::testCmpDefault()
 {
-    String left, right;
+    string left, right;
     /* two default strings are equal */
-    CPPUNIT_ASSERT(!left.cmp(right));
-    CPPUNIT_ASSERT(!left.cmp(NULL));
-    CPPUNIT_ASSERT(!left.cmp(NULL, 1));
+    CPPUNIT_ASSERT(!left.compare(right));
+    CPPUNIT_ASSERT(!left.compare(NULL));
+    CPPUNIT_ASSERT(!left.compare(NULL, 1));
 }
 
 void
 testString::testCmpEmptyString()
 {
-    String left("");
-    String right;
+    string left("");
+    string right;
     /* an empty string ("") is equal to a default string */
-    CPPUNIT_ASSERT(!left.cmp(right));
-    CPPUNIT_ASSERT(!left.cmp(NULL));
-    CPPUNIT_ASSERT(!left.cmp(NULL, 1));
+    CPPUNIT_ASSERT(!left.compare(right));
+    CPPUNIT_ASSERT(!left.compare(NULL));
+    CPPUNIT_ASSERT(!left.compare(NULL, 1));
     /* reverse the order to catch corners */
-    CPPUNIT_ASSERT(!right.cmp(left));
-    CPPUNIT_ASSERT(!right.cmp(""));
-    CPPUNIT_ASSERT(!right.cmp("", 1));
+    CPPUNIT_ASSERT(!right.compare(left));
+    CPPUNIT_ASSERT(!right.compare(""));
+    CPPUNIT_ASSERT(!right.compare("", 1));
 }
 
 void
 testString::testCmpNotEmptyDefault()
 {
-    String left("foo");
-    String right;
+    string left("foo");
+    string right;
     /* empty string sorts before everything */
-    CPPUNIT_ASSERT(left.cmp(right) > 0);
-    CPPUNIT_ASSERT(left.cmp(NULL) > 0);
-    CPPUNIT_ASSERT(left.cmp(NULL, 1) > 0);
+    CPPUNIT_ASSERT(left.compare(right) > 0);
+    CPPUNIT_ASSERT(left.compare(NULL) > 0);
+    CPPUNIT_ASSERT(left.compare(NULL, 1) > 0);
     /* reverse for symmetry tests */
-    CPPUNIT_ASSERT(right.cmp(left) < 0);
-    CPPUNIT_ASSERT(right.cmp("foo") < 0);
-    CPPUNIT_ASSERT(right.cmp("foo", 1) < 0);
+    CPPUNIT_ASSERT(right.compare(left) < 0);
+    CPPUNIT_ASSERT(right.compare("foo") < 0);
+    CPPUNIT_ASSERT(right.compare("foo", 1) < 0);
 }
Index: squid3/src/tests/testString.h
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testString.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- squid3/src/tests/testString.h	3 May 2006 14:04:45 -0000	1.1
+++ squid3/src/tests/testString.h	18 May 2007 06:41:33 -0000	1.2
@@ -11,18 +11,33 @@
 class testString : public CPPUNIT_NS::TestFixture
 {
     CPPUNIT_TEST_SUITE( testString );
+    CPPUNIT_TEST( testDefaults );
+        /* boolean helper tests */
     CPPUNIT_TEST( testCmpDefault );
     CPPUNIT_TEST( testCmpEmptyString );
     CPPUNIT_TEST( testCmpNotEmptyDefault );
+
+    CPPUNIT_TEST( testBooleans );
+    CPPUNIT_TEST( testAppend );
+    CPPUNIT_TEST( testAssignments );
+    CPPUNIT_TEST( testCstrMethods );
+    CPPUNIT_TEST( testSearch );
     CPPUNIT_TEST_SUITE_END();
 
 public:
 
 protected:
+
+    /* std::string API */
+    void testDefaults();
     void testCmpDefault();
     void testCmpEmptyString();
     void testCmpNotEmptyDefault();
+    void testBooleans();
+    void testAppend();
+    void testAssignments();
+    void testCstrMethods();
+    void testSearch();
 };
 
 #endif
-
Index: squid3/src/tests/testURLScheme.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/testURLScheme.cc,v
retrieving revision 1.2
retrieving revision 1.3
diff -u -r1.2 -r1.3
--- squid3/src/tests/testURLScheme.cc	2 Sep 2006 03:54:27 -0000	1.2
+++ squid3/src/tests/testURLScheme.cc	18 May 2007 06:41:33 -0000	1.3
@@ -104,9 +104,9 @@
 void
 testURLScheme::testConst_str()
 {
-    String lhs("wais");
+    string lhs("wais");
     URLScheme wais(PROTO_WAIS);
-    String rhs(wais.const_str());
+    string rhs(wais.const_str());
     CPPUNIT_ASSERT_EQUAL(lhs, rhs);
 }
 
@@ -143,7 +143,7 @@
 {
     std::ostringstream buffer;
     buffer << URLScheme(PROTO_HTTP);
-    String http_str("http");
-    String from_buf(buffer.str().c_str());
+    string http_str("http");
+    string from_buf(buffer.str().c_str());
     CPPUNIT_ASSERT_EQUAL(http_str, from_buf);
 }
Index: squid3/src/tests/test_http_range.cc
===================================================================
RCS file: /cvsroot/squid/squid3/src/tests/test_http_range.cc,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- squid3/src/tests/test_http_range.cc	21 May 2006 14:35:11 -0000	1.1
+++ squid3/src/tests/test_http_range.cc	18 May 2007 06:41:33 -0000	1.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: test_http_range.cc,v 1.1 2006/05/21 14:35:11 robertc Exp $
+ * $Id: test_http_range.cc,v 1.2 2007/05/18 06:41:33 amosjeffries Exp $
  *
  * DEBUG: section 64    HTTP Range Header
  * AUTHOR: Alex Rousskov
@@ -56,10 +56,10 @@
     return NULL;
 }
 
-extern String httpHeaderGetList(const HttpHeader * hdr, http_hdr_type id)
+extern string httpHeaderGetList(const HttpHeader * hdr, http_hdr_type id)
 {
     fatal ("dummy function\n");
-    return String();
+    return "";
 }
 
 SQUIDCEXTERN int httpHeaderHas(const HttpHeader * hdr, http_hdr_type type)
@@ -76,7 +76,7 @@
 void
 testRangeParser(char const *rangestring)
 {
-    String aString (rangestring);
+    string aString (rangestring);
     HttpHdrRange *range = HttpHdrRange::ParseCreate (&aString);
 
     if (!range)
@@ -96,7 +96,7 @@
 HttpHdrRange *
 rangeFromString(char const *rangestring)
 {
-    String aString (rangestring);
+    string aString (rangestring);
     HttpHdrRange *range = HttpHdrRange::ParseCreate (&aString);
 
     if (!range)
